# TODO:
%define biname nginx-redirector

Name: nginx-redirector
Version: 0.2.0.1
Release: alt1

Summary: CLI-utility for building nginx redirects

License: ISC
Group: Networking/WWW
Url: https://gitlab.eterfund.ru/eterfund/nginx-redirector

# Source-git: https://gitlab.eterfund.ru/eterfund/nginx-redirector.git
Source: %name-%version.tar

BuildRequires(pre): rpm-build-intro
BuildRequires(pre): rpm-build-python3

%if_with test
BuildRequires: python3-module-pyinotify
BuildRequires: python3-module-setuptools
BuildRequires: python3-module-yaml
%endif

BuildArch: noarch

%description
NGINX redirector:
* %biname <.yaml file> <.map file> - generate .conf and .map files for redirects for nginx
* %biname-watch <file-to-watch> - set inotify watchdog for this file and renew .map and .conf files for this project when
* %biname-convert <.htaccess file> <.map file> - convert .htaccess to .map file

%prep
%setup

%build
%python3_build

%install
%python3_install
%python3_prune
mkdir -p %buildroot/var/lib/%biname/location-includes
mkdir -p %buildroot/var/lib/%biname/maps
mkdir -p %buildroot/etc/%biname
mkdir -p %buildroot/var/log/%biname

#cp nginx-redirector-watch.service %buildroot/etc/systemd/system/nginx-redirector-watch.service
install -pD -m644 nginx-redirector.service %buildroot%systemd_unitdir/nginx-redirector.service

%check
DIR=$(pwd)
env -i CONFIG_DIR=$DIR/redirector/tests/nginx_test_case/location-includes \
CONFIG=$DIR/redirector/tests/test.yaml \
MAPS_DIR=$DIR/redirector/tests/nginx_test_case/maps \
%python3_test

%files
/usr/bin/%biname
/usr/bin/%biname-watch
/usr/bin/%biname-convert
%python3_sitelibdir/*
/etc/%biname/
%systemd_unitdir/*

/var/lib/%biname/location-includes/
/var/lib/%biname/maps/
/var/log/%biname


%changelog
* Tue Mar 29 2022 Vitaly Lipatov <lav@altlinux.ru> 0.2.0-alt1
- use envs instead of config.ini
- use constants instead of config.ini
- update README.md
- [fix] Fix prefix writing in project redirects
- fix map file search
- fix generated map file
- fix nginx-redirector-watch
- add systemd unit file
- make python 3.5 compatible
- return check section (disabled for now)

* Tue Mar 01 2022 Pablo Soldatoff <soldatoff@etersoft.ru> 0.1.3-alt1
- new version

* Wed Nov 03 2021 Pablo Soldatoff <soldatoff@etersoft.ru> 0.1.2-alt1
- new version

* Mon Jul 27 2020 Eugene Omelyanovich <regatio@etersoft.ru> 0.1.1-alt1
- new version

